QGIS Application - Bug report #7894
QGIS Server - GetPrint request does not respect text boxes size and position if dynamic content

passed
2013-05-24 06:19 AM - Michael Douchin

Status: Closed

Priority: Normal

Assignee: René-Luc RelLuc

Category: QGIS Server

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16767
Description

| have set up a simple composer in QGIS (last master, compiled this morning). See attached picture qgis_composer.png

When | export in PDF from QGIS desktop composer, | get the attached pdf qgis_pdf

When | ran the request [1] which is the getprint (proxy done by LizMap-Web-Client to hide the map parameter), | get the attached pdf
getprind_pdf Basically | added the parameter truc=MY FOO TITLE <b>BOLD</b> )

When | ran the same request but with a longer "truc" parameter, like &truc=MY FOO TITLE <b>BOLD</b><p>Lorem ipsum dolor sit
amet, consectetur adipiscing elit. Quisque luctus adipiscing fringilla. Fusce eget justo tellus. Maecenas dolor augue, sollicitudin at iaculis
et, congue et metus. Aenean tincidunt ipsum sit amet ipsum ornare fermentum. Proin fringilla laoreet hendrerit. Curabitur dui urna,
interdum tempus blandit eu,</p>

| get the attached PDF getprint_long_pdf.pdf

So it appears that the dynamic replacement via the GetPrint request does not respect the position and size of my "truc" text box, whereas
the desktop composer does.
Or this is a problem with word wrapping perhaps ?

(1]
http://localhost/LIZMAP/lizmap-web-client/lizmap/www/index.php/lizmap/service/?repository=dev&#38;project=dev_print&#38;SERVIC
=WMS&#38;VERSION=1.3&#38;REQUEST=GetPrint&#38;FORMAT=pdf&#38;EXCEPTIONS=application/vnd.ogc.se_inimage&#38;TR!

ANSP/

ANSPARENT=true&#38;SRS=EPSG:3857&#38;DPI=300&#38; TEMPLATE=lizmap&#38;map0:extent=423524.8086443924,5400434.83

04808

30480828,431474.979630755,5410235.04125647&#38;map0:rotation=0&#38;map0:scale=49999.99999999999&#38;LAYERS=commu

ne&#3¢

uned#38;truc=MY %20FOO0%20TITLE%20%3Cb%3EBOLD%3C/b%3E

History

#1 - 2013-05-27 06:37 AM - Michael Douchin
- File dev_print.qgs added
- File polygons.geojson added

Some more description added to be able to reproduce the problem.

Since QWebKit requires a running x-server to be able to render HTML, QGIS composers using HTML blocks or text block rendered as html will make

QGIS Server segfault.

As adviced by Marco Hugentobler and Tim Sutton in the thread [1], | describe here the workaroud :
http://localhost/LIZMAP/lizmap-web-client/lizmap/www/index.php/lizmap/service/?repository=dev&#38;project=dev_print&#38;SERVICE=WMS&#38;VERSION=1.3&#38;REQUEST=GetPrint&#38;FORMAT=pdf&#38;EXCEPTIONS=application/vnd.ogc.se_inimage&#38;TRANSPARENT=true&#38;SRS=EPSG:3857&#38;DPI=300&#38;TEMPLATE=lizmap&#38;map0:extent=423524.8086443924,5400434.830480828,431474.979630755,5410235.04125647&#38;map0:rotation=0&#38;map0:scale=49999.99999999999&#38;LAYERS=commune&#38;truc=MY%20FOO%20TITLE%20%3Cb%3EBOLD%3C/b%3E
http://localhost/LIZMAP/lizmap-web-client/lizmap/www/index.php/lizmap/service/?repository=dev&#38;project=dev_print&#38;SERVICE=WMS&#38;VERSION=1.3&#38;REQUEST=GetPrint&#38;FORMAT=pdf&#38;EXCEPTIONS=application/vnd.ogc.se_inimage&#38;TRANSPARENT=true&#38;SRS=EPSG:3857&#38;DPI=300&#38;TEMPLATE=lizmap&#38;map0:extent=423524.8086443924,5400434.830480828,431474.979630755,5410235.04125647&#38;map0:rotation=0&#38;map0:scale=49999.99999999999&#38;LAYERS=commune&#38;truc=MY%20FOO%20TITLE%20%3Cb%3EBOLD%3C/b%3E
http://localhost/LIZMAP/lizmap-web-client/lizmap/www/index.php/lizmap/service/?repository=dev&#38;project=dev_print&#38;SERVICE=WMS&#38;VERSION=1.3&#38;REQUEST=GetPrint&#38;FORMAT=pdf&#38;EXCEPTIONS=application/vnd.ogc.se_inimage&#38;TRANSPARENT=true&#38;SRS=EPSG:3857&#38;DPI=300&#38;TEMPLATE=lizmap&#38;map0:extent=423524.8086443924,5400434.830480828,431474.979630755,5410235.04125647&#38;map0:rotation=0&#38;map0:scale=49999.99999999999&#38;LAYERS=commune&#38;truc=MY%20FOO%20TITLE%20%3Cb%3EBOLD%3C/b%3E
http://localhost/LIZMAP/lizmap-web-client/lizmap/www/index.php/lizmap/service/?repository=dev&#38;project=dev_print&#38;SERVICE=WMS&#38;VERSION=1.3&#38;REQUEST=GetPrint&#38;FORMAT=pdf&#38;EXCEPTIONS=application/vnd.ogc.se_inimage&#38;TRANSPARENT=true&#38;SRS=EPSG:3857&#38;DPI=300&#38;TEMPLATE=lizmap&#38;map0:extent=423524.8086443924,5400434.830480828,431474.979630755,5410235.04125647&#38;map0:rotation=0&#38;map0:scale=49999.99999999999&#38;LAYERS=commune&#38;truc=MY%20FOO%20TITLE%20%3Cb%3EBOLD%3C/b%3E
http://localhost/LIZMAP/lizmap-web-client/lizmap/www/index.php/lizmap/service/?repository=dev&#38;project=dev_print&#38;SERVICE=WMS&#38;VERSION=1.3&#38;REQUEST=GetPrint&#38;FORMAT=pdf&#38;EXCEPTIONS=application/vnd.ogc.se_inimage&#38;TRANSPARENT=true&#38;SRS=EPSG:3857&#38;DPI=300&#38;TEMPLATE=lizmap&#38;map0:extent=423524.8086443924,5400434.830480828,431474.979630755,5410235.04125647&#38;map0:rotation=0&#38;map0:scale=49999.99999999999&#38;LAYERS=commune&#38;truc=MY%20FOO%20TITLE%20%3Cb%3EBOLD%3C/b%3E

- Create a fake X server

Xvfb :99 -ac -noreset &

- Add the option in the fastcgi , for example
FastCgiConfig -idle-timeout 70 -maxClassProcesses 50 -minProcesses 3

-init-start-delay 3 -restart-delay 20 -startDelay 15 -initial-env
DISPLAY=:99

- Restart Apache

service apache2 restart

| also attached a sample project and relative data

[1] http://lists.osgeo.org/pipermail/qgis-developer/2013-May/026228.html

#2 - 2013-05-27 01:12 PM - René-Luc ReLuc

I have found the code, src/mapserver/qgsconfigparser.cpp:530

/Ireplace label text
foreach ( QgsComposerLabel *currentLabel, composerLabels )

{
QString title = parameterMap.value( currentLabel->id().toUpper() );

if ( title.isEmpty() )
{

//remove exported labels not referenced in the request
if ( !currentLabel->id().isEmpty() )
{

c->removeltem( currentLabel );
delete currentLabel;

}
continue;

}

currentLabel->setText( title );
currentLabel->adjustSize ToText();

}

At the end for each label the size is adjusted to the text, but now every label is HTML.

Other question, why removed label if it was not in parameters ?
http://lists.osgeo.org/pipermail/qgis-developer/2013-May/026228.html

#3 - 2013-06-03 12:03 PM - René-Luc ReLuc

- % Done changed from 0 to 100

- Assignee changed from Marco Hugentobler to René-Luc ReLuc
- Status changed from Open to Closed

Update with the commit fe883246707644d{37a0960fba57250226b8f001
